/**
 * @module package/quiqqer/authmetamask/bin/classes/Web3
 * @author www.pcsg.de (Henning Leutz)
 */
define('package/quiqqer/authmetamask/bin/classes/Web3', [

    'qui/classes/DOM',
    URL_OPT_DIR + 'quiqqer/authmetamask/bin/web3.min.js'

], function (QUIDOM, Web3) {
    "use strict";

    return new Class({

        Extends: QUIDOM,
        Type   : 'package/quiqqer/authmetamask/bin/classes/Web3',

        initialize: function (options) {
            this.parent(options);

            this.$Web3 = null;
        },

        getWeb3: function () {
            if (this.$Web3) {
                return Promise.resolve(this.$Web3);
            }

            var self = this;

            // metamask
            if (window.ethereum) {
                return new Promise(function (resolve, reject) {
                    window.ethereum.request({method: 'eth_requestAccounts'}).then(function () {
                        self.$Web3 = new Web3(window.ethereum);

                        resolve(self.$Web3);
                    }).catch((e) => {
                        reject(e);
                    });
                });
            }

            if (typeof Web3.givenProvider !== 'undefined') {
                self.$Web3 = new Web3(Web3.givenProvider || "ws://localhost:8545");
                return Promise.resolve(this.$Web3);
            }

            // use old provider
            // deprecated
            // if (typeof window.web3 !== 'undefined' &&
            //     typeof window.web3.currentProvider !== 'undefined') {
            //     self.$Web3 = new Web3(web3.currentProvider);
            //     return Promise.resolve(self.$Web3);
            // }

            self.$Web3 = new Web3();
            return Promise.reject('Web3 is missing');
        }
    });
});
