<?php

/**
 * This file contains QUI\Auth\MetaMask\Controls
 */

namespace QUI\Auth\MetaMask\Controls;

use QUI;
use QUI\Control;

/**
 * Class Login
 *
 * @package QUI\Auth\MetaMask\Controls
 */
class Login extends Control
{
    /**
     * Login constructor.
     *
     * @param array $attributes
     */
    public function __construct(array $attributes = [])
    {
        parent::__construct($attributes);

        $this->addCSSClass('quiqqer-metamask-login');
        $this->addCSSFile(dirname(__FILE__) . '/Login.css');
        $this->setAttribute('icon', URL_OPT_DIR . 'quiqqer/authmetamask/bin/MetaMaskLogo.png');
    }

    /**
     * @return string
     */
    public function getBody(): string
    {
        try {
            $Engine = QUI::getTemplateManager()->getEngine();
            $Conf = QUI::getPackage('quiqqer/authmetamask')->getConfig();
        } catch (QUI\Exception) {
            return '';
        }

        $Engine->assign([
            'autoLogin' => $Conf->get('authSettings', 'autoLogin') ? "1" : "0"
        ]);

        return $Engine->fetch(dirname(__FILE__) . '/Login.html');
    }
}
